#pragma once
#include "olcPixelGameEngine.h"
#include "olcPGEX_TransformedView.h"
#include "Resources.h"
#include "Unit.h"

class Textbox{
	std::string headerText=""; //If a textbox has a header, it displays at the top in a special color.
	std::string displayHeaderText="";
	std::string text="";
	std::string displayText="";
	vf2d pos={};
	vf2d maxSize={};
	float lastLetterTime=0;
	float letterDisplayDelay=0.01;
	int textboxMarker=-1;
	int lastWordMarker=-1;
	std::string lastWord="";
	int lastHeaderWordMarker=-1;
	std::string lastHeaderWord="";
	std::vector<Memory> resourceCost; //If resource cost is greater than 0, shows them.
	bool visible=true;
	Pixel backCol=CONSTANT::MESSAGE_BOX_DEFAULT_BACKCOL;
public:
	Textbox();
	void Initialize(std::string text,vf2d pos={},std::string headerText="",vf2d maxSize={120,1},std::vector<Memory>resourceCost={},float letterDisplayDelay=0.01);

	void UpdateAndDraw(vf2d pos,PixelGameEngine*pge,Resources&resources,std::map<Image,std::unique_ptr<Renderable>>&IMAGES);
	std::string&GetCurrentString();
	void SetVisible(bool visible);
	vf2d GetSize();
	void SetBackgroundColor(Pixel col);
private:
	void Update(PixelGameEngine*pge);
	void UpdatePosition(vf2d newPos);
	void Draw(PixelGameEngine*pge,Resources&resources,std::map<Image,std::unique_ptr<Renderable>>&IMAGES);
	void SetDefaults();
};